/*
 * Copyright © 2016-2018 European Support Limited
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.openecomp.sdc.vendorsoftwareproduct.impl;

import org.openecomp.core.dao.UniqueValueDaoFactory;
import org.openecomp.core.model.dao.EnrichedServiceModelDaoFactory;
import org.openecomp.core.model.dao.ServiceModelDaoFactory;
import org.openecomp.sdc.vendorlicense.VendorLicenseArtifactServiceFactory;
import org.openecomp.sdc.vendorlicense.facade.VendorLicenseFacadeFactory;
import org.openecomp.sdc.vendorsoftwareproduct.OrchestrationTemplateCandidateManagerFactory;
import org.openecomp.sdc.vendorsoftwareproduct.VendorSoftwareProductManager;
import org.openecomp.sdc.vendorsoftwareproduct.VspManagerFactory;
import org.openecomp.sdc.vendorsoftwareproduct.dao.*;
import org.openecomp.sdc.vendorsoftwareproduct.factory.CandidateServiceFactory;
import org.openecomp.sdc.vendorsoftwareproduct.factory.InformationArtifactGeneratorFactory;

public class VspManagerFactoryImpl extends VspManagerFactory {
  private static final VendorSoftwareProductManager INSTANCE =
      new VendorSoftwareProductManagerImpl(
          VspMergeDaoFactory.getInstance().createInterface(),
          OrchestrationTemplateDaoFactory.getInstance().createInterface(),
          OrchestrationTemplateCandidateManagerFactory.getInstance().createInterface(),
          VendorSoftwareProductInfoDaoFactory.getInstance().createInterface(),
          VendorLicenseFacadeFactory.getInstance().createInterface(),
          ServiceModelDaoFactory.getInstance().createInterface(),
          EnrichedServiceModelDaoFactory.getInstance().createInterface(),
          VendorLicenseArtifactServiceFactory.getInstance().createInterface(),
          InformationArtifactGeneratorFactory.getInstance().createInterface(),
          PackageInfoDaoFactory.getInstance().createInterface(),
          DeploymentFlavorDaoFactory.getInstance().createInterface(),
          ComponentDaoFactory.getInstance().createInterface(),
          ComponentDependencyModelDaoFactory.getInstance().createInterface(),
          NicDaoFactory.getInstance().createInterface(),
          ComputeDaoFactory.getInstance().createInterface(),
          ImageDaoFactory.getInstance().createInterface(),
          new ManualVspToscaManagerImpl(),
          UniqueValueDaoFactory.getInstance().createInterface(), CandidateServiceFactory
          .getInstance().createInterface());

  @Override
  public VendorSoftwareProductManager createInterface() {
    return INSTANCE;
  }
}
